// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.administration.programStrategy;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Définit les Taxons relatifs à une stratégie de collecte, éventuellement le niveau de priorité de
 * la collecte sur le Taxon.
 * @see ReferenceTaxonStrategy
 */
public interface ReferenceTaxonStrategyDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link ReferenceTaxonStrategy}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of ReferenceTaxonStrategy from the persistent store.
     * @param referenceTaxonStrategyPk
     * @return ReferenceTaxonStrategy
     */
    public ReferenceTaxonStrategy get(ReferenceTaxonStrategyPK referenceTaxonStrategyPk);

    /**
     * <p>
     * Does the same thing as {@link #get(ReferenceTaxonStrategyPK)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param referenceTaxonStrategyPk the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, ReferenceTaxonStrategyPK referenceTaxonStrategyPk);

    /**
     * Loads an instance of ReferenceTaxonStrategy from the persistent store.
     * @param referenceTaxonStrategyPk
     * @return ReferenceTaxonStrategy
     */
    public ReferenceTaxonStrategy load(ReferenceTaxonStrategyPK referenceTaxonStrategyPk);

    /**
     * <p>
     * Does the same thing as {@link #load(ReferenceTaxonStrategyPK)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param referenceTaxonStrategyPk the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, ReferenceTaxonStrategyPK referenceTaxonStrategyPk);

    /**
     * Loads all entities of type {@link ReferenceTaxonStrategy}.
     *
     * @return the loaded entities.
     */
    public Collection<ReferenceTaxonStrategy> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of ReferenceTaxonStrategy and adds it to the persistent store.
     * @param referenceTaxonStrategy
     * @return ReferenceTaxonStrategy
     */
    public ReferenceTaxonStrategy create(ReferenceTaxonStrategy referenceTaxonStrategy);

    /**
     * <p>
     * Does the same thing as {@link #create(ReferenceTaxonStrategy)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param referenceTaxonStrategy
     * @return Object
     */
    public Object create(int transform, ReferenceTaxonStrategy referenceTaxonStrategy);

    /**
     * Creates a new instance of ReferenceTaxonStrategy and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of ReferenceTaxonStrategy
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<ReferenceTaxonStrategy> create(Collection<ReferenceTaxonStrategy> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(ReferenceTaxonStrategy)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<ReferenceTaxonStrategy> entities);

    /**
     * <p>
     * Creates a new <code>ReferenceTaxonStrategy</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param priorityLevel Niveau de priorité de collecte de données sur un taxon. Si non renseigné, il faut alors considérer
qu'aucun niveau de priorité n'est utilisé dans la stratégie.
Exemple :
Dans l'échantillonnage à terre, il existe trois niveaux de priorité de collecte d'espèces :
- priorité 1 : Anguille (Anguilla anguilla), crevettes rouges (Aristeomorpha foliacea, Aristeus
antennatus), anchois (Engraulis encrasilosus), merlu (Merluccius merluccius), rougets (Mullus
barbatus, Mullus surmuletus), langoustine (Nephrops norvegicus), crevette blanche (Parapenaeus
longirostris), sole (solea vulgaris), sardine (Sardina pilchardus), auxquels s’ajoutent toutes les
espèces de thonidés et les elasmobranches (raies et requins).
- priorité 2 : On citera pour le golfe du Lion les baudroies (Lophius spp.), le bar (Dicentrarchus
labrax), le poulpe (eledone spp., Octopus vulgaris), les encornets (Illex spp., Todadores spp.), les
grondins (Eutrigla gurnardus, Trigla lucerna), le maquereau (Scomber spp.), la dorade royale (Sparus
aurata) et le chinchard (Trachurus trachurus).
     * @return ReferenceTaxonStrategy
     */
    public ReferenceTaxonStrategy create(
        Short priorityLevel);

    /**
     * <p>
     * Does the same thing as {@link #create(Short)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param priorityLevel Niveau de priorité de collecte de données sur un taxon. Si non renseigné, il faut alors considérer
qu'aucun niveau de priorité n'est utilisé dans la stratégie.
Exemple :
Dans l'échantillonnage à terre, il existe trois niveaux de priorité de collecte d'espèces :
- priorité 1 : Anguille (Anguilla anguilla), crevettes rouges (Aristeomorpha foliacea, Aristeus
antennatus), anchois (Engraulis encrasilosus), merlu (Merluccius merluccius), rougets (Mullus
barbatus, Mullus surmuletus), langoustine (Nephrops norvegicus), crevette blanche (Parapenaeus
longirostris), sole (solea vulgaris), sardine (Sardina pilchardus), auxquels s’ajoutent toutes les
espèces de thonidés et les elasmobranches (raies et requins).
- priorité 2 : On citera pour le golfe du Lion les baudroies (Lophius spp.), le bar (Dicentrarchus
labrax), le poulpe (eledone spp., Octopus vulgaris), les encornets (Illex spp., Todadores spp.), les
grondins (Eutrigla gurnardus, Trigla lucerna), le maquereau (Scomber spp.), la dorade royale (Sparus
aurata) et le chinchard (Trachurus trachurus).
     * @return ReferenceTaxonStrategy
     */
    public Object create(
        int transform,
        Short priorityLevel);

    /**
     * <p>
     * Creates a new <code>ReferenceTaxonStrategy</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param referenceTaxon
     * @param strategy
     * @return ReferenceTaxonStrategy
     */
    public ReferenceTaxonStrategy create(
        ReferenceTaxon referenceTaxon,
        Strategy strategy);

    /**
     * <p>
     * Does the same thing as {@link #create()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param referenceTaxon
     * @param strategy
     * @return Object
     */
    public Object create(
        int transform,
        ReferenceTaxon referenceTaxon,
        Strategy strategy);

    /**
     * Updates the <code>referenceTaxonStrategy</code> instance in the persistent store.
     * @param referenceTaxonStrategy
     */
    public void update(ReferenceTaxonStrategy referenceTaxonStrategy);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<ReferenceTaxonStrategy> entities);

    /**
     * Removes the instance of ReferenceTaxonStrategy from the persistent store.
     * @param referenceTaxonStrategy
     */
    public void remove(ReferenceTaxonStrategy referenceTaxonStrategy);

    /**
     * Removes the instance of ReferenceTaxonStrategy having the given
     * <code>identifier</code> from the persistent store.
     * @param referenceTaxonStrategyPk
     */
    public void remove(ReferenceTaxonStrategyPK referenceTaxonStrategyPk);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<ReferenceTaxonStrategy> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<ReferenceTaxonStrategy> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.administration.programStrategy.ReferenceTaxonStrategyDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.administration.programStrategy.ReferenceTaxonStrategyDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final ReferenceTaxonStrategy entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,ReferenceTaxonStrategy)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.administration.programStrategy.ReferenceTaxonStrategyDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,ReferenceTaxonStrategy)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}