// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.data.history;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.referential.ObjectType;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Permet de tracer les modifications intervenues dans sur une entité (une
 * marée, une vente, etc).
 * </p>
 * <p>
 * Les anciennes valeurs de l'entité y sont tracées. Pour la plupart, il
 * s'agit d'une valeur numérique, ou des liens vers les référentiels les
 * plus utilisés.
 * </p>
 * <p>
 * </p>
 * <p>
 * <b>Les modifications portant sur les dates ou champs alphanumériques ne
 * sont pas tracés. </b>Généralement, des modifications de ce type
 * correspond à une nouvelle donnée.
 * </p>
 * <p>
 * </p>
 * <p>
 * Un commentaire doit etre associé à chaque ligne, indiquant la l'objet de
 * l'opération de modification effectuée.
 * </p>
 * <p>
 * </p>
 * <p>
 * <u><b>ATTENTION</b></u> : <i>recorderDepartment</i> et <i>recorderPerson</i>
 * ne sont pas les anciennes valeurs des champs de la donnée qui a été
 * modifiée, car ces champs ne devraient jamais être modifiée pour une
 * donnée (c’est le service/la personne ayant crée la donnée).
 * </p>
 * <p>
 * <b>Les champs <i>recorderDepartment</i> et <i>recorderPerson</i> de
 * ItemHistory sont remplis avec le service/la personne qui a fait la
 * modification.</b>
 * </p>
 * </body>
 * </html>
 * @see UpdatedItemHistory
 */
public interface UpdatedItemHistoryDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link UpdatedItemHistory}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of UpdatedItemHistory from the persistent store.
     * @param id
     * @return UpdatedItemHistory
     */
    public UpdatedItemHistory get(Long id);

    /**
     * <p>
     * Does the same thing as {@link #get(Long)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Long id);

    /**
     * Loads an instance of UpdatedItemHistory from the persistent store.
     * @param id
     * @return UpdatedItemHistory
     */
    public UpdatedItemHistory load(Long id);

    /**
     * <p>
     * Does the same thing as {@link #load(Long)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Long id);

    /**
     * Loads all entities of type {@link UpdatedItemHistory}.
     *
     * @return the loaded entities.
     */
    public Collection<UpdatedItemHistory> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of UpdatedItemHistory and adds it to the persistent store.
     * @param updatedItemHistory
     * @return UpdatedItemHistory
     */
    public UpdatedItemHistory create(UpdatedItemHistory updatedItemHistory);

    /**
     * <p>
     * Does the same thing as {@link #create(UpdatedItemHistory)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param updatedItemHistory
     * @return Object
     */
    public Object create(int transform, UpdatedItemHistory updatedItemHistory);

    /**
     * Creates a new instance of UpdatedItemHistory and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of UpdatedItemHistory
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<UpdatedItemHistory> create(Collection<UpdatedItemHistory> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(UpdatedItemHistory)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<UpdatedItemHistory> entities);

    /**
     * <p>
     * Creates a new <code>UpdatedItemHistory</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param objectId Identifiant de l''entité manipulée.
     * @param objectCode 
     * @param isPostValidation <html>
<head>
</head>
<body>
<p>
Indique si la donn&#233;e &#233;tait valid&#233;e ou non au moment de la
modification/correction.
<br>    </p>
<p>
</p>
<p>
&quot;1&quot; (=Vrai) si la donn&#233;e &#233;tait d&#233;j&#224; valid&#233;e, &quot;0&quot;
(=Faux) sinon.
<br>
<br>Dans le processus de validation/qualification des donn&#233;es, ce flag permet
de savoir s'il s'agit d'une modification (=donn&#233;e non encore valid&#233;e) ou
d'une correction faite par un expert (=surune donn&#233;e valid&#233;e)
</p>
</body>
</html>
     * @param comments Commentaire de l'opération de qualification
     * @param numericalValue Valeur numérique précédente
     * @param previousComments <html>
<head>
</head>
<body>
<p>
Pr&#233;c&#233;dent commentaire de qualification (valeur pr&#233;c&#233;dente de
<i>&lt;entit&#233;&gt;.qualificationComments</i>).
</p>
</body>
</html>
     * @param updateDate 
     * @param remoteId 
     * @return UpdatedItemHistory
     */
    public UpdatedItemHistory create(
        Integer objectId,
        String objectCode,
        Boolean isPostValidation,
        String comments,
        Float numericalValue,
        String previousComments,
        Timestamp updateDate,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(Integer, String, Boolean, String, Float, String, Timestamp, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param objectId Identifiant de l''entité manipulée.
     * @param objectCode 
     * @param isPostValidation <html>
<head>
</head>
<body>
<p>
Indique si la donn&#233;e &#233;tait valid&#233;e ou non au moment de la
modification/correction.
<br>    </p>
<p>
</p>
<p>
&quot;1&quot; (=Vrai) si la donn&#233;e &#233;tait d&#233;j&#224; valid&#233;e, &quot;0&quot;
(=Faux) sinon.
<br>
<br>Dans le processus de validation/qualification des donn&#233;es, ce flag permet
de savoir s'il s'agit d'une modification (=donn&#233;e non encore valid&#233;e) ou
d'une correction faite par un expert (=surune donn&#233;e valid&#233;e)
</p>
</body>
</html>
     * @param comments Commentaire de l'opération de qualification
     * @param numericalValue Valeur numérique précédente
     * @param previousComments <html>
<head>
</head>
<body>
<p>
Pr&#233;c&#233;dent commentaire de qualification (valeur pr&#233;c&#233;dente de
<i>&lt;entit&#233;&gt;.qualificationComments</i>).
</p>
</body>
</html>
     * @param updateDate 
     * @param remoteId 
     * @return UpdatedItemHistory
     */
    public Object create(
        int transform,
        Integer objectId,
        String objectCode,
        Boolean isPostValidation,
        String comments,
        Float numericalValue,
        String previousComments,
        Timestamp updateDate,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>UpdatedItemHistory</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param comments
     * @param isPostValidation
     * @param objectType
     * @param recorderDepartment
     * @return UpdatedItemHistory
     */
    public UpdatedItemHistory create(
        String comments,
        Boolean isPostValidation,
        ObjectType objectType,
        Department recorderDepartment);

    /**
     * <p>
     * Does the same thing as {@link #create(Boolean, String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param comments
     * @param isPostValidation
     * @param objectType
     * @param recorderDepartment
     * @return Object
     */
    public Object create(
        int transform,
        String comments,
        Boolean isPostValidation,
        ObjectType objectType,
        Department recorderDepartment);

    /**
     * Updates the <code>updatedItemHistory</code> instance in the persistent store.
     * @param updatedItemHistory
     */
    public void update(UpdatedItemHistory updatedItemHistory);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<UpdatedItemHistory> entities);

    /**
     * Removes the instance of UpdatedItemHistory from the persistent store.
     * @param updatedItemHistory
     */
    public void remove(UpdatedItemHistory updatedItemHistory);

    /**
     * Removes the instance of UpdatedItemHistory having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Long id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<UpdatedItemHistory> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<UpdatedItemHistory> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.data.history.UpdatedItemHistoryDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.data.history.UpdatedItemHistoryDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final UpdatedItemHistory entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,UpdatedItemHistory)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.data.history.UpdatedItemHistoryDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,UpdatedItemHistory)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}