// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.data.produce;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.data.measure.ProduceQuantificationMeasurement;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroup;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * <html>
 * <head>
 * </head>
 * <body>
 * <p>
 * Un produit est identifi&#233; par une esp&#232;ce commerciale, un &#233;tat, une
 * qualit&#233;, pr&#233;sentation et cat&#233;gorie commerciale.
 * </p>
 * <p>
 * </p>
 * <p>
 * <u>Si le produit est un &quot;produit vendu&quot; :</u>
 * </p>
 * <p>
 * On pourra allors utiliser SortingMeasurement pour stocker des donn&#233;es
 * &#233;conomiques, comme par exemple :
 * </p>
 * <p>
 * - Le prix du produit. Il peut y avoir plusieurds prix (plusieurs PSFMs),
 * par exemple : prix au kilo, et prix total en euros.
 * </p>
 * <p>
 * - Valorisation de la commercialisation : Label rouge, Eco Label, marque
 * collective control&#233;e par un organisme tier. (cf SACROIS)
 * </p>
 * <p>
 * - Destination commerciale : consommation humaine, consommation animale,
 * etc .
 * </p>
 * </body>
 * </html>
 * @see Produce
 */
public interface ProduceDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link Produce}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of Produce from the persistent store.
     * @param id
     * @return Produce
     */
    public Produce get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of Produce from the persistent store.
     * @param id
     * @return Produce
     */
    public Produce load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link Produce}.
     *
     * @return the loaded entities.
     */
    public Collection<Produce> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of Produce and adds it to the persistent store.
     * @param produce
     * @return Produce
     */
    public Produce create(Produce produce);

    /**
     * <p>
     * Does the same thing as {@link #create(Produce)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param produce
     * @return Object
     */
    public Object create(int transform, Produce produce);

    /**
     * Creates a new instance of Produce and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of Produce
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<Produce> create(Collection<Produce> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(Produce)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<Produce> entities);

    /**
     * <p>
     * Creates a new <code>Produce</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param isDiscard Le produit est-il un rejet ou non ?
     * @param subgroupCount Nombre de sous ensembles ayant servit à la quantification.
Par exemple il pourra s'agir d'un nombre de caisse servant à quantifié le produit.
Par exemple, pour une détermination de la quantification par les volumes :
- nombre_sous_ensembles_quantifiés = 3
- poids moyen par sous-ensemble = 5 kg
=> Poids total du lot = 3 x 5 = 15kg
     * @param individualCount Nombre d'individus (optionnel). Utile pour les très gros individu.
Ex : 1 espadon de 150kg
     * @param taxonGroupOtherInformation Autre information sur l'espèce du produit.
Utilisé dans SACROIS/RIC2, pour stocker des informations complémentaires issues du référentiel
espèce du Réseau Inter Criée (RIC).
     * @param controlDate 
     * @param validationDate 
     * @param qualificationDate 
     * @param qualificationComments 
     * @param weight Poids total du lot/produit (en kg).
Il peut s'agir d'une poids vif ou d'un poids brut, suivant si la la présence ou l'absence de l’état
et de la présentation.
@since 3.5.0
     * @param cost Prix total, exprimé dans l'unité utilisée par du système SIH (€, DH, SR, ...)
@since 3.5.0
     * @param remoteId 
     * @return Produce
     */
    public Produce create(
        Boolean isDiscard,
        Float subgroupCount,
        Short individualCount,
        String taxonGroupOtherInformation,
        Date controlDate,
        Date validationDate,
        Date qualificationDate,
        String qualificationComments,
        Float weight,
        Float cost,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(Boolean, Float, Short, String, Date, Date, Date, String, Float, Float, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param isDiscard Le produit est-il un rejet ou non ?
     * @param subgroupCount Nombre de sous ensembles ayant servit à la quantification.
Par exemple il pourra s'agir d'un nombre de caisse servant à quantifié le produit.
Par exemple, pour une détermination de la quantification par les volumes :
- nombre_sous_ensembles_quantifiés = 3
- poids moyen par sous-ensemble = 5 kg
=> Poids total du lot = 3 x 5 = 15kg
     * @param individualCount Nombre d'individus (optionnel). Utile pour les très gros individu.
Ex : 1 espadon de 150kg
     * @param taxonGroupOtherInformation Autre information sur l'espèce du produit.
Utilisé dans SACROIS/RIC2, pour stocker des informations complémentaires issues du référentiel
espèce du Réseau Inter Criée (RIC).
     * @param controlDate 
     * @param validationDate 
     * @param qualificationDate 
     * @param qualificationComments 
     * @param weight Poids total du lot/produit (en kg).
Il peut s'agir d'une poids vif ou d'un poids brut, suivant si la la présence ou l'absence de l’état
et de la présentation.
@since 3.5.0
     * @param cost Prix total, exprimé dans l'unité utilisée par du système SIH (€, DH, SR, ...)
@since 3.5.0
     * @param remoteId 
     * @return Produce
     */
    public Object create(
        int transform,
        Boolean isDiscard,
        Float subgroupCount,
        Short individualCount,
        String taxonGroupOtherInformation,
        Date controlDate,
        Date validationDate,
        Date qualificationDate,
        String qualificationComments,
        Float weight,
        Float cost,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>Produce</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param isDiscard
     * @param produceQuantificationMeasurements
     * @param qualityFlag
     * @param taxonGroup
     * @return Produce
     */
    public Produce create(
        Boolean isDiscard,
        Collection<ProduceQuantificationMeasurement> produceQuantificationMeasurements,
        QualityFlag qualityFlag,
        TaxonGroup taxonGroup);

    /**
     * <p>
     * Does the same thing as {@link #create(Boolean)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param isDiscard
     * @param produceQuantificationMeasurements
     * @param qualityFlag
     * @param taxonGroup
     * @return Object
     */
    public Object create(
        int transform,
        Boolean isDiscard,
        Collection<ProduceQuantificationMeasurement> produceQuantificationMeasurements,
        QualityFlag qualityFlag,
        TaxonGroup taxonGroup);

    /**
     * Updates the <code>produce</code> instance in the persistent store.
     * @param produce
     */
    public void update(Produce produce);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<Produce> entities);

    /**
     * Removes the instance of Produce from the persistent store.
     * @param produce
     */
    public void remove(Produce produce);

    /**
     * Removes the instance of Produce having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<Produce> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<Produce> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.data.produce.ProduceDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.data.produce.ProduceDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final Produce entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,Produce)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.data.produce.ProduceDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,Produce)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}