// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.survey.fishingTrip;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import java.io.Serializable;

/**
 * Définie l'origine d'un marée.
 * Par exemple, Une marée reconstituée peut provenir d'un calcul à partir des données VMS recoupée à
 * partir des données de vente.
 * Il peut y avoir autant de FishingTripOrigin que de marées d'origine (marées sources).
 */
// HibernateEntity.vsl annotations merge-point
public abstract class FishingTripOrigin
    implements Serializable, Comparable<FishingTripOrigin>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 6014478835888822087L;

    // Generate 2 attributes
    private Integer id;

    /**
     * 
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * 
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private Integer remoteId;

    /**
     * 
     * @return this.remoteId Integer
     */
    public Integer getRemoteId()
    {
        return this.remoteId;
    }

    /**
     * 
     * @param remoteIdIn Integer
     */
    public void setRemoteId(Integer remoteIdIn)
    {
        this.remoteId = remoteIdIn;
    }

    // Generate 3 associations
    private Program program;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Identifie le progamme d'origine, ayant servi à constituer la marée (par
     * Copier/coller, consolidation, croisement, etc).
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemple :
     * </p>
     * <p>
     * - Pour un marée SIH-RECOPESCA, on indiquera ici le programme
     * &quot;SIH-preRECOPESCA&quot;;
     * </p>
     * <p>
     * - Pour une marée SIH-SACROIS, on indiquera le programme dont sont issus
     * les Logbooks, etc.
     * </p>
     * </body>
     * </html>
     * @return this.program Program
     */
    public Program getProgram()
    {
        return this.program;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * Identifie le progamme d'origine, ayant servi à constituer la marée (par
     * Copier/coller, consolidation, croisement, etc).
     * </p>
     * <p>
     * </p>
     * <p>
     * Exemple :
     * </p>
     * <p>
     * - Pour un marée SIH-RECOPESCA, on indiquera ici le programme
     * &quot;SIH-preRECOPESCA&quot;;
     * </p>
     * <p>
     * - Pour une marée SIH-SACROIS, on indiquera le programme dont sont issus
     * les Logbooks, etc.
     * </p>
     * </body>
     * </html>
     * @param programIn Program
     */
    public void setProgram(Program programIn)
    {
        this.program = programIn;
    }

    private FishingTrip originFishingTrip;

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * @deprecated : utiliser <i>LinkedItem</i>
     * </p>
     * <p>
     * </p>
     * <p>
     * Identifie la marée d'origine, ayant servie à remplir la marée courante.
     * cette liaison est optionnelle, car l'identifiant de la marée d'origine
     * n'est pas toujours connues.
     * </p>
     * <p>
     * </p>
     * <p>
     * A noter que la notion de &quot;rapprochement&quot; (cf <i>LinkedItem</i>)
     * est plus souple pour établir des liaisons entre données de différents
     * programmes. Cette notion est a privilégier car elle ne contraind pas les
     * suppressions de données, comme le fait un lien physique tel que
     * ORIGIN_FISHING_TRIP_FK.
     * </p>
     * </body>
     * </html>
     * @return this.originFishingTrip FishingTrip
     */
    public FishingTrip getOriginFishingTrip()
    {
        return this.originFishingTrip;
    }

    /**
     * <html>
     * <head>
     * <style>
     * p {padding:0px; margin:0px;}
     * </style>
     * </head>
     * <body>
     * <p>
     * @deprecated : utiliser <i>LinkedItem</i>
     * </p>
     * <p>
     * </p>
     * <p>
     * Identifie la marée d'origine, ayant servie à remplir la marée courante.
     * cette liaison est optionnelle, car l'identifiant de la marée d'origine
     * n'est pas toujours connues.
     * </p>
     * <p>
     * </p>
     * <p>
     * A noter que la notion de &quot;rapprochement&quot; (cf <i>LinkedItem</i>)
     * est plus souple pour établir des liaisons entre données de différents
     * programmes. Cette notion est a privilégier car elle ne contraind pas les
     * suppressions de données, comme le fait un lien physique tel que
     * ORIGIN_FISHING_TRIP_FK.
     * </p>
     * </body>
     * </html>
     * @param originFishingTripIn FishingTrip
     */
    public void setOriginFishingTrip(FishingTrip originFishingTripIn)
    {
        this.originFishingTrip = originFishingTripIn;
    }

    private FishingTrip fishingTrip;

    /**
     * Voyage en mer, ayant pour vocation une activité de peche (peut etre une campagnes halieutique
     * ou une
     * marée d'un navire professionnel, etc.)
     * Un voyage peut représenter type de données :
     * - Une marée observée (en mer, au débarquement), qui désigne une marée de pêche
     * professionnelle au
     * cours de laquelle des relevés sont effectués par un observateur.
     * - Une marée déclarée. Principalement issue du log book électronique (flux SACAPT). Une marée
     * déclarée peut etre un ensemble de marée ou de sous-ensembles de marée (Exemple de la fiche de
     * peche)
     * - une sortie effectuée lors d"une campagne scientifique
     * @return this.fishingTrip FishingTrip
     */
    public FishingTrip getFishingTrip()
    {
        return this.fishingTrip;
    }

    /**
     * Voyage en mer, ayant pour vocation une activité de peche (peut etre une campagnes halieutique
     * ou une
     * marée d'un navire professionnel, etc.)
     * Un voyage peut représenter type de données :
     * - Une marée observée (en mer, au débarquement), qui désigne une marée de pêche
     * professionnelle au
     * cours de laquelle des relevés sont effectués par un observateur.
     * - Une marée déclarée. Principalement issue du log book électronique (flux SACAPT). Une marée
     * déclarée peut etre un ensemble de marée ou de sous-ensembles de marée (Exemple de la fiche de
     * peche)
     * - une sortie effectuée lors d"une campagne scientifique
     * @param fishingTripIn FishingTrip
     */
    public void setFishingTrip(FishingTrip fishingTripIn)
    {
        this.fishingTrip = fishingTripIn;
    }

    /**
     * Returns <code>true</code> if the argument is an FishingTripOrigin instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof FishingTripOrigin))
        {
            return false;
        }
        final FishingTripOrigin that = (FishingTripOrigin)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link FishingTripOrigin}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link FishingTripOrigin}.
         * @return new FishingTripOriginImpl()
         */
        public static FishingTripOrigin newInstance()
        {
            return new FishingTripOriginImpl();
        }

        /**
         * Constructs a new instance of {@link FishingTripOrigin}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param program Program
         * @param fishingTrip FishingTrip
         * @return newInstance
         */
        public static FishingTripOrigin newInstance(Program program, FishingTrip fishingTrip)
        {
            final FishingTripOrigin entity = new FishingTripOriginImpl();
            entity.setProgram(program);
            entity.setFishingTrip(fishingTrip);
            return entity;
        }

        /**
         * Constructs a new instance of {@link FishingTripOrigin}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param remoteId Integer
         * @param program Program
         * @param originFishingTrip FishingTrip
         * @param fishingTrip FishingTrip
         * @return newInstance FishingTripOrigin
         */
        public static FishingTripOrigin newInstance(Integer remoteId, Program program, FishingTrip originFishingTrip, FishingTrip fishingTrip)
        {
            final FishingTripOrigin entity = new FishingTripOriginImpl();
            entity.setRemoteId(remoteId);
            entity.setProgram(program);
            entity.setOriginFishingTrip(originFishingTrip);
            entity.setFishingTrip(fishingTrip);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(FishingTripOrigin o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getRemoteId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRemoteId().compareTo(o.getRemoteId()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// FishingTripOrigin.java merge-point
}