// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.survey.fishingTrip;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.administration.user.Person;
import fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement;
import fr.ifremer.adagio.core.dao.data.operation.Operation;
import fr.ifremer.adagio.core.dao.data.sale.ExpectedSale;
import fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference;
import fr.ifremer.adagio.core.dao.data.survey.landing.Landing;
import fr.ifremer.adagio.core.dao.data.survey.sale.Sale;
import fr.ifremer.adagio.core.dao.data.survey.scientificCruise.ScientificCruise;
import fr.ifremer.adagio.core.dao.data.transshipment.Transshipment;
import fr.ifremer.adagio.core.dao.data.vessel.Vessel;
import fr.ifremer.adagio.core.dao.data.vessel.feature.person.VesselPersonFeatures;
import fr.ifremer.adagio.core.dao.data.vessel.feature.physical.GearPhysicalFeatures;
import fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import fr.ifremer.adagio.core.dao.referential.samplingScheme.denormalized.DenormalizedSamplingStrata;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Une marée observée en mer désigne une marée de pêche professionnelle au cours de laquelle des
 * relevés sont effectués par un observateur.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class ObservedFishingTrip
    extends FishingTripImpl
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -1860694243330256265L;

    // Generate 0 attributes
    // Generate 3 associations
    private Collection<Person> observerPersons = new HashSet<Person>();

    /**
     * Liste des observateurs d'une marée observée.
     * @return this.observerPersons Collection<Person>
     */
    public Collection<Person> getObserverPersons()
    {
        return this.observerPersons;
    }

    /**
     * Liste des observateurs d'une marée observée.
     * @param observerPersonsIn Collection<Person>
     */
    public void setObserverPersons(Collection<Person> observerPersonsIn)
    {
        this.observerPersons = observerPersonsIn;
    }

    /**
     * Liste des observateurs d'une marée observée.
     * @param elementToAdd Person
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addObserverPersons(Person elementToAdd)
    {
        return this.observerPersons.add(elementToAdd);
    }

    /**
     * Liste des observateurs d'une marée observée.
     * @param elementToRemove Person
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeObserverPersons(Person elementToRemove)
    {
        return this.observerPersons.remove(elementToRemove);
    }

    private Collection<ExpectedSale> expectedSales = new HashSet<ExpectedSale>();

    /**
     * Mode de vente escompté (d’une marée observée ou d'un débarquement observé).
     * @return this.expectedSales Collection<ExpectedSale>
     */
    public Collection<ExpectedSale> getExpectedSales()
    {
        return this.expectedSales;
    }

    /**
     * Mode de vente escompté (d’une marée observée ou d'un débarquement observé).
     * @param expectedSalesIn Collection<ExpectedSale>
     */
    public void setExpectedSales(Collection<ExpectedSale> expectedSalesIn)
    {
        this.expectedSales = expectedSalesIn;
    }

    /**
     * Mode de vente escompté (d’une marée observée ou d'un débarquement observé).
     * @param elementToAdd ExpectedSale
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addExpectedSales(ExpectedSale elementToAdd)
    {
        return this.expectedSales.add(elementToAdd);
    }

    /**
     * Mode de vente escompté (d’une marée observée ou d'un débarquement observé).
     * @param elementToRemove ExpectedSale
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeExpectedSales(ExpectedSale elementToRemove)
    {
        return this.expectedSales.remove(elementToRemove);
    }

    private DenormalizedSamplingStrata samplingStrata;

    /**
     * Porte la référence du plan d'échantillonnage.
     * Par exemple, la référence gérée par le site web WAO.
     * @return this.samplingStrata DenormalizedSamplingStrata
     */
    public DenormalizedSamplingStrata getSamplingStrata()
    {
        return this.samplingStrata;
    }

    /**
     * Porte la référence du plan d'échantillonnage.
     * Par exemple, la référence gérée par le site web WAO.
     * @param samplingStrataIn DenormalizedSamplingStrata
     */
    public void setSamplingStrata(DenormalizedSamplingStrata samplingStrataIn)
    {
        this.samplingStrata = samplingStrataIn;
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>FishingTripImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip#equals(Object)
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>FishingTripImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip#hashCode()
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link ObservedFishingTrip}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link ObservedFishingTrip}.
         * @return new ObservedFishingTripImpl()
         */
        public static ObservedFishingTrip newInstance()
        {
            return new ObservedFishingTripImpl();
        }

        /**
         * Constructs a new instance of {@link ObservedFishingTrip}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param synchronizationStatus String
         * @param creationDate Date
         * @param recorderDepartment Department
         * @param qualityFlag QualityFlag
         * @param program Program
         * @param vessel Vessel
         * @return newInstance
         */
        public static ObservedFishingTrip newInstance(String synchronizationStatus, Date creationDate, Department recorderDepartment, QualityFlag qualityFlag, Program program, Vessel vessel)
        {
            final ObservedFishingTrip entity = new ObservedFishingTripImpl();
            entity.setSynchronizationStatus(synchronizationStatus);
            entity.setCreationDate(creationDate);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setQualityFlag(qualityFlag);
            entity.setProgram(program);
            entity.setVessel(vessel);
            return entity;
        }

        /**
         * Constructs a new instance of {@link ObservedFishingTrip}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param synchronizationStatus String
         * @param departureDateTime Date
         * @param returnDateTime Date
         * @param position String
         * @param comments String
         * @param creationDate Date
         * @param controlDate Date
         * @param validationDate Date
         * @param qualificationDate Date
         * @param qualificationComments String
         * @param updateDate Timestamp
         * @param remoteId Integer
         * @param returnLocation Location
         * @param departureLocation Location
         * @param vesselPersonFeatures Collection<VesselPersonFeatures>
         * @param recorderDepartment Department
         * @param recorderPerson Person
         * @param operations Collection<Operation>
         * @param qualityFlag QualityFlag
         * @param fishingTripOrigins Collection<FishingTripOrigin>
         * @param program Program
         * @param vessel Vessel
         * @param sales Collection<Sale>
         * @param scientificCruise ScientificCruise
         * @param declaredDocumentReference DeclaredDocumentReference
         * @param landings Collection<Landing>
         * @param transshipments Collection<Transshipment>
         * @param vesselUseFeatures Collection<VesselUseFeatures>
         * @param gearPhysicalFeatures Collection<GearPhysicalFeatures>
         * @param surveyMeasurements Collection<SurveyMeasurement>
         * @param observerPersons Collection<Person>
         * @param expectedSales Collection<ExpectedSale>
         * @param samplingStrata DenormalizedSamplingStrata
         * @return newInstance ObservedFishingTrip
         */
        public static ObservedFishingTrip newInstance(String synchronizationStatus, Date departureDateTime, Date returnDateTime, String position, String comments, Date creationDate, Date controlDate, Date validationDate, Date qualificationDate, String qualificationComments, Timestamp updateDate, Integer remoteId, Location returnLocation, Location departureLocation, Collection<VesselPersonFeatures> vesselPersonFeatures, Department recorderDepartment, Person recorderPerson, Collection<Operation> operations, QualityFlag qualityFlag, Collection<FishingTripOrigin> fishingTripOrigins, Program program, Vessel vessel, Collection<Sale> sales, ScientificCruise scientificCruise, DeclaredDocumentReference declaredDocumentReference, Collection<Landing> landings, Collection<Transshipment> transshipments, Collection<VesselUseFeatures> vesselUseFeatures, Collection<GearPhysicalFeatures> gearPhysicalFeatures, Collection<SurveyMeasurement> surveyMeasurements, Collection<Person> observerPersons, Collection<ExpectedSale> expectedSales, DenormalizedSamplingStrata samplingStrata)
        {
            final ObservedFishingTrip entity = new ObservedFishingTripImpl();
            entity.setSynchronizationStatus(synchronizationStatus);
            entity.setDepartureDateTime(departureDateTime);
            entity.setReturnDateTime(returnDateTime);
            entity.setPosition(position);
            entity.setComments(comments);
            entity.setCreationDate(creationDate);
            entity.setControlDate(controlDate);
            entity.setValidationDate(validationDate);
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setUpdateDate(updateDate);
            entity.setRemoteId(remoteId);
            entity.setReturnLocation(returnLocation);
            entity.setDepartureLocation(departureLocation);
            entity.setVesselPersonFeatures(vesselPersonFeatures);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setRecorderPerson(recorderPerson);
            entity.setOperations(operations);
            entity.setQualityFlag(qualityFlag);
            entity.setFishingTripOrigins(fishingTripOrigins);
            entity.setProgram(program);
            entity.setVessel(vessel);
            entity.setSales(sales);
            entity.setScientificCruise(scientificCruise);
            entity.setDeclaredDocumentReference(declaredDocumentReference);
            entity.setLandings(landings);
            entity.setTransshipments(transshipments);
            entity.setVesselUseFeatures(vesselUseFeatures);
            entity.setGearPhysicalFeatures(gearPhysicalFeatures);
            entity.setSurveyMeasurements(surveyMeasurements);
            entity.setObserverPersons(observerPersons);
            entity.setExpectedSales(expectedSales);
            entity.setSamplingStrata(samplingStrata);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(ObservedFishingTrip o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// ObservedFishingTrip.java merge-point
}