// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.data.survey.scientificCruise;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import fr.ifremer.adagio.core.dao.administration.user.Department;
import fr.ifremer.adagio.core.dao.administration.user.Person;
import fr.ifremer.adagio.core.dao.data.vessel.Vessel;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * <html>
 * <head>
 * </head>
 * <body>
 * <p>
 * Campagne scientifique.
 * </p>
 * <p>
 * <br><u>D&#233;finiition :</u>
 * </p>
 * <p>
 * </p>
 * <p>
 * The period of time during which a scientific research vessel is operated
 * in furtherance of a scientific research project, beginning when the
 * vessel leaves port to undertake the project and ending when the vessel
 * completes the project as provided for in the applicable scientific
 * research plan.
 * </p>
 * <p>
 * </p>
 * <p>
 * <i>US Dept. of Commerce (1996):
 * http://caldera.sero.nmfs.gov/fishery/regs/inter600.htm#B</i>
 * </p>
 * </body>
 * </html>
 * @see ScientificCruise
 */
public interface ScientificCruiseDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link ScientificCruise}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of ScientificCruise from the persistent store.
     * @param id
     * @return ScientificCruise
     */
    public ScientificCruise get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of ScientificCruise from the persistent store.
     * @param id
     * @return ScientificCruise
     */
    public ScientificCruise load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link ScientificCruise}.
     *
     * @return the loaded entities.
     */
    public Collection<ScientificCruise> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of ScientificCruise and adds it to the persistent store.
     * @param scientificCruise
     * @return ScientificCruise
     */
    public ScientificCruise create(ScientificCruise scientificCruise);

    /**
     * <p>
     * Does the same thing as {@link #create(ScientificCruise)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param scientificCruise
     * @return Object
     */
    public Object create(int transform, ScientificCruise scientificCruise);

    /**
     * Creates a new instance of ScientificCruise and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of ScientificCruise
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<ScientificCruise> create(Collection<ScientificCruise> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(ScientificCruise)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<ScientificCruise> entities);

    /**
     * <p>
     * Creates a new <code>ScientificCruise</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param synchronizationStatus Etat de synchronisation (en cours, terminé, en attente de synchro, supprimé). Seulement visible dans
la base locale.
     * @param name Libellé décrivant la campagne. Ne pas renseigner si SISMER.
     * @param departureDateTime Date et heure de départ de la campagne scientifique.
     * @param returnDateTime Date et heure de départ de la campagne scientifique. Optionnel.
     * @param reference Lien vers le serveur SISMER. Probablement la référence SISMER de la campagne CAM_CAMREF
(FI351997020020 par exemple)
     * @param comments Commentaire sur la campagne. Ne pas renseigner si SISMER.
     * @param creationDate 
     * @param updateDate Date de dernière mise à jour.
     * @param remoteId 
     * @return ScientificCruise
     */
    public ScientificCruise create(
        String synchronizationStatus,
        String name,
        Date departureDateTime,
        Date returnDateTime,
        String reference,
        String comments,
        Date creationDate,
        Timestamp updateDate,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, Date, Date, String, String, Date, Timestamp, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param synchronizationStatus Etat de synchronisation (en cours, terminé, en attente de synchro, supprimé). Seulement visible dans
la base locale.
     * @param name Libellé décrivant la campagne. Ne pas renseigner si SISMER.
     * @param departureDateTime Date et heure de départ de la campagne scientifique.
     * @param returnDateTime Date et heure de départ de la campagne scientifique. Optionnel.
     * @param reference Lien vers le serveur SISMER. Probablement la référence SISMER de la campagne CAM_CAMREF
(FI351997020020 par exemple)
     * @param comments Commentaire sur la campagne. Ne pas renseigner si SISMER.
     * @param creationDate 
     * @param updateDate Date de dernière mise à jour.
     * @param remoteId 
     * @return ScientificCruise
     */
    public Object create(
        int transform,
        String synchronizationStatus,
        String name,
        Date departureDateTime,
        Date returnDateTime,
        String reference,
        String comments,
        Date creationDate,
        Timestamp updateDate,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>ScientificCruise</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param creationDate
     * @param departureDateTime
     * @param managerPerson
     * @param name
     * @param program
     * @param recorderDepartment
     * @param synchronizationStatus
     * @param vessel
     * @return ScientificCruise
     */
    public ScientificCruise create(
        Date creationDate,
        Date departureDateTime,
        Person managerPerson,
        String name,
        Program program,
        Department recorderDepartment,
        String synchronizationStatus,
        Vessel vessel);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, Date, Date)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param creationDate
     * @param departureDateTime
     * @param managerPerson
     * @param name
     * @param program
     * @param recorderDepartment
     * @param synchronizationStatus
     * @param vessel
     * @return Object
     */
    public Object create(
        int transform,
        Date creationDate,
        Date departureDateTime,
        Person managerPerson,
        String name,
        Program program,
        Department recorderDepartment,
        String synchronizationStatus,
        Vessel vessel);

    /**
     * Updates the <code>scientificCruise</code> instance in the persistent store.
     * @param scientificCruise
     */
    public void update(ScientificCruise scientificCruise);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<ScientificCruise> entities);

    /**
     * Removes the instance of ScientificCruise from the persistent store.
     * @param scientificCruise
     */
    public void remove(ScientificCruise scientificCruise);

    /**
     * Removes the instance of ScientificCruise having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<ScientificCruise> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<ScientificCruise> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.data.survey.scientificCruise.ScientificCruiseDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.data.survey.scientificCruise.ScientificCruiseDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final ScientificCruise entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,ScientificCruise)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.data.survey.scientificCruise.ScientificCruiseDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,ScientificCruise)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}