// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.conversion;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue;
import fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroup;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * <html>
 * <head>
 * </head>
 * <body>
 * <p>
 * <b>Equivalent poids vif </b>:<br><br>
 * </p>
 * <p>
 * Le calcul se fait par multiplication du poids total du lot par un
 * coefficient multiplicateur (convCoeff) . Ce coefficient est obtenu &#224;
 * partir des caract&#233;ristiques suivantes :<br>- esp&#232;ce commerciale :
 * TaxonGroup<br>- pr&#233;sentation du poisson: fishPresentation (ex :
 * &quot;Entier&quot;, &quot;Vid&#233;&quot;, &quot;&#201;t&#234;t&#233;, vid&#233;,
 * &#233;queut&#233;&quot;, &quot;D&#233;cortiqu&#233;&quot;, ...).<br>-
 * Etat du poisson : fishState (ex : &quot;frais&quot;, &quot;congel&#233;&quot;,
 * &quot;sal&#233;&quot;,
 * &quot;s&#233;ch&#233;&quot;...).<br>- Pays dans lequel s&#8217;est effectu&#233;e
 * la capture.
 * </p>
 * <p>
 * <u>Definition FAO :</u> &quot;Round Weigth&quot; : the weight of the whole fish
 * before processing or removal of any part.<br>FAO (1998): Guidelines for
 * the routine collection of capture fishery data. FAO Fish. Tech. Pap,
 * 382: 113 p.
 * </p>
 * </body>
 * </html>
 * @see RoundWeightConversion
 */
public interface RoundWeightConversionDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link RoundWeightConversion}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of RoundWeightConversion from the persistent store.
     * @param id
     * @return RoundWeightConversion
     */
    public RoundWeightConversion get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of RoundWeightConversion from the persistent store.
     * @param id
     * @return RoundWeightConversion
     */
    public RoundWeightConversion load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link RoundWeightConversion}.
     *
     * @return the loaded entities.
     */
    public Collection<RoundWeightConversion> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of RoundWeightConversion and adds it to the persistent store.
     * @param roundWeightConversion
     * @return RoundWeightConversion
     */
    public RoundWeightConversion create(RoundWeightConversion roundWeightConversion);

    /**
     * <p>
     * Does the same thing as {@link #create(RoundWeightConversion)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param roundWeightConversion
     * @return Object
     */
    public Object create(int transform, RoundWeightConversion roundWeightConversion);

    /**
     * Creates a new instance of RoundWeightConversion and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of RoundWeightConversion
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<RoundWeightConversion> create(Collection<RoundWeightConversion> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(RoundWeightConversion)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<RoundWeightConversion> entities);

    /**
     * <p>
     * Creates a new <code>RoundWeightConversion</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param conversionCoefficient Coefficient de conversion pour l'équivalent poids vif.
     * @param startDate 
     * @param endDate 
     * @param description 
     * @param updateDate 
     * @return RoundWeightConversion
     */
    public RoundWeightConversion create(
        Float conversionCoefficient,
        Date startDate,
        Date endDate,
        String description,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(Float, Date, Date, String, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param conversionCoefficient Coefficient de conversion pour l'équivalent poids vif.
     * @param startDate 
     * @param endDate 
     * @param description 
     * @param updateDate 
     * @return RoundWeightConversion
     */
    public Object create(
        int transform,
        Float conversionCoefficient,
        Date startDate,
        Date endDate,
        String description,
        Timestamp updateDate);

    /**
     * <p>
     * Creates a new <code>RoundWeightConversion</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param conversionCoefficient
     * @param dressing
     * @param location
     * @param preserving
     * @param startDate
     * @param taxonGroup
     * @return RoundWeightConversion
     */
    public RoundWeightConversion create(
        Float conversionCoefficient,
        QualitativeValue dressing,
        Location location,
        QualitativeValue preserving,
        Date startDate,
        TaxonGroup taxonGroup);

    /**
     * <p>
     * Does the same thing as {@link #create(Float, Date)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param conversionCoefficient
     * @param dressing
     * @param location
     * @param preserving
     * @param startDate
     * @param taxonGroup
     * @return Object
     */
    public Object create(
        int transform,
        Float conversionCoefficient,
        QualitativeValue dressing,
        Location location,
        QualitativeValue preserving,
        Date startDate,
        TaxonGroup taxonGroup);

    /**
     * Updates the <code>roundWeightConversion</code> instance in the persistent store.
     * @param roundWeightConversion
     */
    public void update(RoundWeightConversion roundWeightConversion);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<RoundWeightConversion> entities);

    /**
     * Removes the instance of RoundWeightConversion from the persistent store.
     * @param roundWeightConversion
     */
    public void remove(RoundWeightConversion roundWeightConversion);

    /**
     * Removes the instance of RoundWeightConversion having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<RoundWeightConversion> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<RoundWeightConversion> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.referential.conversion.RoundWeightConversionDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.referential.conversion.RoundWeightConversionDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final RoundWeightConversion entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,RoundWeightConversion)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.referential.conversion.RoundWeightConversionDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,RoundWeightConversion)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}