// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.spatial;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import java.io.Serializable;

/**
 * 
 */
// HibernateEntity.vsl annotations merge-point
public abstract class SpatialItemPoint
    implements Serializable, Comparable<SpatialItemPoint>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 1158031680335317423L;

    // Generate 3 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String localizedName;

    /**
     * Libellé régionalisé, valable sur la géométrie, pour l'entité correspondante.
     * par exemple, pour une zone de présence d'une espèce comemrciale, cela peut etre le nom
     * vernaculaire, etc.
     * @return this.localizedName String
     */
    public String getLocalizedName()
    {
        return this.localizedName;
    }

    /**
     * Libellé régionalisé, valable sur la géométrie, pour l'entité correspondante.
     * par exemple, pour une zone de présence d'une espèce comemrciale, cela peut etre le nom
     * vernaculaire, etc.
     * @param localizedNameIn String
     */
    public void setLocalizedName(String localizedNameIn)
    {
        this.localizedName = localizedNameIn;
    }

    private String position;

    /**
     * 
     * @return this.position String
     */
    public String getPosition()
    {
        return this.position;
    }

    /**
     * 
     * @param positionIn String
     */
    public void setPosition(String positionIn)
    {
        this.position = positionIn;
    }

    // Generate 1 associations
    private SpatialItem spatialItem;

    /**
     * Présence d'un élément d'une liste du référentiel sur une ou plusieurs zones géographiques.
     * Une ou plusieurs géométrie (ponctuelle, linéraire ou polygonale) peuvent etre définies afin
     * de
     * géolocaliser un des éléments d'une liste.
     * Une procédure stockée sous Oracle permet la mise à jour d'un lien vers le référentiel des
     * lieux
     * (table SPATIAL_ITEM2LOCATION) à partir des géométries définies.
     * @return this.spatialItem SpatialItem
     */
    public SpatialItem getSpatialItem()
    {
        return this.spatialItem;
    }

    /**
     * Présence d'un élément d'une liste du référentiel sur une ou plusieurs zones géographiques.
     * Une ou plusieurs géométrie (ponctuelle, linéraire ou polygonale) peuvent etre définies afin
     * de
     * géolocaliser un des éléments d'une liste.
     * Une procédure stockée sous Oracle permet la mise à jour d'un lien vers le référentiel des
     * lieux
     * (table SPATIAL_ITEM2LOCATION) à partir des géométries définies.
     * @param spatialItemIn SpatialItem
     */
    public void setSpatialItem(SpatialItem spatialItemIn)
    {
        this.spatialItem = spatialItemIn;
    }

    /**
     * Returns <code>true</code> if the argument is an SpatialItemPoint instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof SpatialItemPoint))
        {
            return false;
        }
        final SpatialItemPoint that = (SpatialItemPoint)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link SpatialItemPoint}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link SpatialItemPoint}.
         * @return new SpatialItemPointImpl()
         */
        public static SpatialItemPoint newInstance()
        {
            return new SpatialItemPointImpl();
        }

        /**
         * Constructs a new instance of {@link SpatialItemPoint}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param spatialItem SpatialItem
         * @return newInstance
         */
        public static SpatialItemPoint newInstance(SpatialItem spatialItem)
        {
            final SpatialItemPoint entity = new SpatialItemPointImpl();
            entity.setSpatialItem(spatialItem);
            return entity;
        }

        /**
         * Constructs a new instance of {@link SpatialItemPoint}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param localizedName String
         * @param position String
         * @param spatialItem SpatialItem
         * @return newInstance SpatialItemPoint
         */
        public static SpatialItemPoint newInstance(String localizedName, String position, SpatialItem spatialItem)
        {
            final SpatialItemPoint entity = new SpatialItemPointImpl();
            entity.setLocalizedName(localizedName);
            entity.setPosition(position);
            entity.setSpatialItem(spatialItem);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(SpatialItemPoint o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getLocalizedName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getLocalizedName().compareTo(o.getLocalizedName()));
            }
            if (this.getPosition() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getPosition().compareTo(o.getPosition()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// SpatialItemPoint.java merge-point
}