// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.data.operation.denormalized;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * ATTENTION : Table technique. (RAZ des données possible) Ne pas remplir directement, mais passer
 * par OPERATION.
 * Opération sous forme dénormalisée (mise en colonne des mesures, etc).
 * L'intéret est l'optimisation des routine d'extraction (ex : extraction COST), d'exploitation des
 * données (reporting BIRT), etc.
 * @see DenormalizedOperation
 */
public interface DenormalizedOperationDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link DenormalizedOperation}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of DenormalizedOperation from the persistent store.
     * @param id
     * @return DenormalizedOperation
     */
    public DenormalizedOperation get(Long id);

    /**
     * <p>
     * Does the same thing as {@link #get(Long)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Long id);

    /**
     * Loads an instance of DenormalizedOperation from the persistent store.
     * @param id
     * @return DenormalizedOperation
     */
    public DenormalizedOperation load(Long id);

    /**
     * <p>
     * Does the same thing as {@link #load(Long)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Long id);

    /**
     * Loads all entities of type {@link DenormalizedOperation}.
     *
     * @return the loaded entities.
     */
    public Collection<DenormalizedOperation> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of DenormalizedOperation and adds it to the persistent store.
     * @param denormalizedOperation
     * @return DenormalizedOperation
     */
    public DenormalizedOperation create(DenormalizedOperation denormalizedOperation);

    /**
     * <p>
     * Does the same thing as {@link #create(DenormalizedOperation)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param denormalizedOperation
     * @return Object
     */
    public Object create(int transform, DenormalizedOperation denormalizedOperation);

    /**
     * Creates a new instance of DenormalizedOperation and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of DenormalizedOperation
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<DenormalizedOperation> create(Collection<DenormalizedOperation> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(DenormalizedOperation)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<DenormalizedOperation> entities);

    /**
     * <p>
     * Creates a new <code>DenormalizedOperation</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param rankOrder Numéro d'ordre de l'opération dans la marée.
L'ordre est déterminée par un tri par odre croissant des dates de fin d'opération.
     * @param isLandingSampling La partie retenue a t'elle été échantillonnée comme le prévoit le protocole ?
(cf manuel de l'observateur du programme de collecte concerné)
     * @param isDiscardSampling La partie non retenue a t'elle été échantillonnée comme le prévoit le protocole ?
(cf manuel de l'observateur du programme de collecte concerné)
     * @param gearMeshSize Maillage étiré de l'engin (en millimètre)
     * @param gearDepth Profondeur moyenne de l'engin (en mètre).
ref : COST
     * @param mainWaterDepth Hauteur d'eau moyenne (en mètre)?
ref : COST ?
     * @param updateDate 
     * @param remoteId 
     * @return DenormalizedOperation
     */
    public DenormalizedOperation create(
        Short rankOrder,
        Boolean isLandingSampling,
        Boolean isDiscardSampling,
        Float gearMeshSize,
        Float gearDepth,
        Float mainWaterDepth,
        Timestamp updateDate,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(Short, Boolean, Boolean, Float, Float, Float, Timestamp, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param rankOrder Numéro d'ordre de l'opération dans la marée.
L'ordre est déterminée par un tri par odre croissant des dates de fin d'opération.
     * @param isLandingSampling La partie retenue a t'elle été échantillonnée comme le prévoit le protocole ?
(cf manuel de l'observateur du programme de collecte concerné)
     * @param isDiscardSampling La partie non retenue a t'elle été échantillonnée comme le prévoit le protocole ?
(cf manuel de l'observateur du programme de collecte concerné)
     * @param gearMeshSize Maillage étiré de l'engin (en millimètre)
     * @param gearDepth Profondeur moyenne de l'engin (en mètre).
ref : COST
     * @param mainWaterDepth Hauteur d'eau moyenne (en mètre)?
ref : COST ?
     * @param updateDate 
     * @param remoteId 
     * @return DenormalizedOperation
     */
    public Object create(
        int transform,
        Short rankOrder,
        Boolean isLandingSampling,
        Boolean isDiscardSampling,
        Float gearMeshSize,
        Float gearDepth,
        Float mainWaterDepth,
        Timestamp updateDate,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>DenormalizedOperation</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param fishingTrip
     * @param isDiscardSampling
     * @param isLandingSampling
     * @param rankOrder
     * @return DenormalizedOperation
     */
    public DenormalizedOperation create(
        FishingTrip fishingTrip,
        Boolean isDiscardSampling,
        Boolean isLandingSampling,
        Short rankOrder);

    /**
     * <p>
     * Does the same thing as {@link #create(Short, Boolean, Boolean)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param fishingTrip
     * @param isDiscardSampling
     * @param isLandingSampling
     * @param rankOrder
     * @return Object
     */
    public Object create(
        int transform,
        FishingTrip fishingTrip,
        Boolean isDiscardSampling,
        Boolean isLandingSampling,
        Short rankOrder);

    /**
     * Updates the <code>denormalizedOperation</code> instance in the persistent store.
     * @param denormalizedOperation
     */
    public void update(DenormalizedOperation denormalizedOperation);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<DenormalizedOperation> entities);

    /**
     * Removes the instance of DenormalizedOperation from the persistent store.
     * @param denormalizedOperation
     */
    public void remove(DenormalizedOperation denormalizedOperation);

    /**
     * Removes the instance of DenormalizedOperation having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Long id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<DenormalizedOperation> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<DenormalizedOperation> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.data.operation.denormalized.DenormalizedOperationDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.data.operation.denormalized.DenormalizedOperationDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final DenormalizedOperation entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,DenormalizedOperation)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.data.operation.denormalized.DenormalizedOperationDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,DenormalizedOperation)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}